use super::verifier::Verifier;
use crate::prelude::CertificateStore;
use std::net::TcpStream;

#[derive(Debug)]
pub struct Builder<S: CertificateStore> {
    pub stream: Option<TcpStream>,
    pub verifier: Option<Verifier<S>>,
}

impl<S: CertificateStore> Default for Builder<S> {
    fn default() -> Self {
        Self { stream: None, verifier: None }
    }
}

impl<S: CertificateStore> Builder<S> {
    pub fn new() -> Self {
        Self::default()
    }

    pub fn stream(mut self, stream: TcpStream) -> Self {
        self.stream = Some(stream);
        self
    }

    pub fn verifier(mut self, verifier: Verifier<S>) -> Self {
        self.verifier = Some(verifier);
        self
    }

    pub fn build(self) -> super::Connection {
        todo!()
    }
}
